Index: drivers/filesystems/btrfs/read.c
===================================================================
--- drivers/filesystems/btrfs/read.c	(révision 74430)
+++ drivers/filesystems/btrfs/read.c	(copie de travail)
@@ -2790,32 +2248,25 @@
     for (i = 0; i < ci->num_stripes; i++) {
         PIO_STACK_LOCATION IrpSp;
         
-        if (devices[i] && stripestart[i] != stripeend[i]) {
-            context->stripes[i].context = (struct read_data_context*)context;
-            context->stripes[i].buf = ExAllocatePoolWithTag(NonPagedPool, stripeend[i] - stripestart[i], ALLOC_TAG);
-            
-            if (!context->stripes[i].buf) {
-                ERR("out of memory\n");
-                Status = STATUS_INSUFFICIENT_RESOURCES;
-                goto exit;
-            }
-            
+        if (devices[i] && context.stripes[i].stripestart != context.stripes[i].stripeend && context.stripes[i].status != ReadDataStatus_Skip) {
+            context.stripes[i].context = (struct read_data_context*)&context;
+
             if (type == BLOCK_FLAG_RAID10) {
-                context->stripes[i].stripenum = i / ci->sub_stripes;
+                context.stripes[i].stripenum = i / ci->sub_stripes;
             }
 
             if (!Irp) {
-                context->stripes[i].Irp = IoAllocateIrp(devices[i]->devobj->StackSize, FALSE);
+                context.stripes[i].Irp = IoAllocateIrp(devices[i]->devobj->StackSize, FALSE);
                 
-                if (!context->stripes[i].Irp) {
+                if (!context.stripes[i].Irp) {
                     ERR("IoAllocateIrp failed\n");
                     Status = STATUS_INSUFFICIENT_RESOURCES;
                     goto exit;
                 }
             } else {
-                context->stripes[i].Irp = IoMakeAssociatedIrp(Irp, devices[i]->devobj->StackSize);
+                context.stripes[i].Irp = IoMakeAssociatedIrp(Irp, devices[i]->devobj->StackSize);
                 
-                if (!context->stripes[i].Irp) {
+                if (!context.stripes[i].Irp) {
                     ERR("IoMakeAssociatedIrp failed\n");
                     Status = STATUS_INSUFFICIENT_RESOURCES;
                     goto exit;
@@ -2822,32 +2273,34 @@
                 }
             }
             
-            IrpSp = IoGetNextIrpStackLocation(context->stripes[i].Irp);
+            IrpSp = IoGetNextIrpStackLocation(context.stripes[i].Irp);
             IrpSp->MajorFunction = IRP_MJ_READ;
             
             if (devices[i]->devobj->Flags & DO_BUFFERED_IO) {
-                FIXME("FIXME - buffered IO\n");
-            } else if (devices[i]->devobj->Flags & DO_DIRECT_IO) {
-                context->stripes[i].Irp->MdlAddress = IoAllocateMdl(context->stripes[i].buf, stripeend[i] - stripestart[i], FALSE, FALSE, NULL);
-                if (!context->stripes[i].Irp->MdlAddress) {
-                    ERR("IoAllocateMdl failed\n");
-                    Status = STATUS_INSUFFICIENT_RESOURCES;
-                    goto exit;
+                context.stripes[i].Irp->AssociatedIrp.SystemBuffer = ExAllocatePoolWithTag(NonPagedPool, context.stripes[i].stripeend - context.stripes[i].stripestart, ALLOC_TAG);
+                if (!context.stripes[i].Irp->AssociatedIrp.SystemBuffer) {
+                    ERR("out of memory\n");
+                    return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
-                MmProbeAndLockPages(context->stripes[i].Irp->MdlAddress, KernelMode, IoWriteAccess);
-            } else {
-                context->stripes[i].Irp->UserBuffer = context->stripes[i].buf;
-            }
 
-            IrpSp->Parameters.Read.Length = stripeend[i] - stripestart[i];
-            IrpSp->Parameters.Read.ByteOffset.QuadPart = stripestart[i] + cis[i].offset;
+                context.stripes[i].Irp->Flags |= IRP_BUFFERED_IO | IRP_DEALLOCATE_BUFFER | IRP_INPUT_OPERATION;
+               
+                context.stripes[i].Irp->UserBuffer = MmGetSystemAddressForMdlSafe(context.stripes[i].mdl, NormalPagePriority);
+            } else if (devices[i]->devobj->Flags & DO_DIRECT_IO)
+                context.stripes[i].Irp->MdlAddress = context.stripes[i].mdl;
+            else
+                context.stripes[i].Irp->UserBuffer = MmGetSystemAddressForMdlSafe(context.stripes[i].mdl, NormalPagePriority);
+
+            IrpSp->Parameters.Read.Length = context.stripes[i].stripeend - context.stripes[i].stripestart;
+            IrpSp->Parameters.Read.ByteOffset.QuadPart = context.stripes[i].stripestart + cis[i].offset;
             
-            context->stripes[i].Irp->UserIosb = &context->stripes[i].iosb;
+            total_reading += IrpSp->Parameters.Read.Length;
             
-            IoSetCompletionRoutine(context->stripes[i].Irp, read_data_completion, &context->stripes[i], TRUE, TRUE, TRUE);
+            context.stripes[i].Irp->UserIosb = &context.stripes[i].iosb;
+            
+            IoSetCompletionRoutine(context.stripes[i].Irp, read_data_completion, &context.stripes[i], TRUE, TRUE, TRUE);
 
-            context->stripes[i].status = ReadDataStatus_Pending;
+            context.stripes[i].status = ReadDataStatus_Pending;
         }
     }
     
@@ -2857,12 +2310,12 @@
 #endif
     
     for (i = 0; i < ci->num_stripes; i++) {
-        if (context->stripes[i].status != ReadDataStatus_MissingDevice) {
-            IoCallDriver(devices[i]->devobj, context->stripes[i].Irp);
+        if (context.stripes[i].status != ReadDataStatus_MissingDevice && context.stripes[i].status != ReadDataStatus_Skip) {
+            IoCallDriver(devices[i]->devobj, context.stripes[i].Irp);
         }
     }
 
-    KeWaitForSingleObject(&context->Event, Executive, KernelMode, FALSE, NULL);
+    KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
    
 #ifdef DEBUG_STATS
     if (!is_tree) {
@@ -2871,12 +2324,15 @@
         Vcb->stats.read_disk_time += time2.QuadPart - time1.QuadPart;
     }
 #endif
+
+    if (diskacc)
+        FsRtlUpdateDiskCounters(total_reading, 0);
     
     // check if any of the devices return a "user-induced" error
     
     for (i = 0; i < ci->num_stripes; i++) {
-        if (context->stripes[i].status == ReadDataStatus_Error && IoIsErrorUserInduced(context->stripes[i].iosb.Status)) {
-            if (Irp && context->stripes[i].iosb.Status == STATUS_VERIFY_REQUIRED) {
+        if (context.stripes[i].status == ReadDataStatus_Error && IoIsErrorUserInduced(context.stripes[i].iosb.Status)) {
+            if (Irp && context.stripes[i].iosb.Status == STATUS_VERIFY_REQUIRED) {
                 PDEVICE_OBJECT dev;
                 
                 dev = IoGetDeviceToVerify(Irp->Tail.Overlay.Thread);
@@ -2892,64 +2348,105 @@
                 if (dev)
                     IoVerifyVolume(dev, FALSE);
             }
-//             IoSetHardErrorOrVerifyDevice(context->stripes[i].Irp, devices[i]->devobj);
+//             IoSetHardErrorOrVerifyDevice(context.stripes[i].Irp, devices[i]->devobj);
             
-            Status = context->stripes[i].iosb.Status;
+            Status = context.stripes[i].iosb.Status;
             goto exit;
         }
     }
     
     if (type == BLOCK_FLAG_RAID0) {
-        Status = read_data_raid0(Vcb, buf, addr, length, context, ci, stripestart, stripeend, startoffstripe);
+        Status = read_data_raid0(Vcb, file_read ? context.va : buf, addr, length, &context, ci, devices, generation, offset);
         if (!NT_SUCCESS(Status)) {
             ERR("read_data_raid0 returned %08x\n", Status);
+            
+            if (file_read)
+                ExFreePool(context.va);
+            
             goto exit;
         }
+        
+        if (file_read) {
+            RtlCopyMemory(buf, context.va, length);
+            ExFreePool(context.va);
+        }
     } else if (type == BLOCK_FLAG_RAID10) {
-        Status = read_data_raid10(Vcb, buf, addr, length, Irp, context, ci, devices, stripestart, stripeend, startoffstripe);
+        Status = read_data_raid10(Vcb, file_read ? context.va : buf, addr, length, &context, ci, devices, generation, offset);
+        
         if (!NT_SUCCESS(Status)) {
             ERR("read_data_raid10 returned %08x\n", Status);
+            
+            if (file_read)
+                ExFreePool(context.va);
+            
             goto exit;
         }
+        
+        if (file_read) {
+            RtlCopyMemory(buf, context.va, length);
+            ExFreePool(context.va);
+        }
     } else if (type == BLOCK_FLAG_DUPLICATE) {
-        Status = read_data_dup(Vcb, buf, addr, length, Irp, context, ci, devices, stripestart, stripeend);
+        Status = read_data_dup(Vcb, addr, &context, ci, devices, generation);
         if (!NT_SUCCESS(Status)) {
             ERR("read_data_dup returned %08x\n", Status);
             goto exit;
         }
     } else if (type == BLOCK_FLAG_RAID5) {
-        Status = read_data_raid5(Vcb, buf, addr, length, Irp, context, ci, devices, stripestart, stripeend, offset, firststripesize, check_nocsum_parity);
+        Status = read_data_raid5(Vcb, file_read ? context.va : buf, addr, length, &context, ci, devices, offset, generation, c);
         if (!NT_SUCCESS(Status)) {
             ERR("read_data_raid5 returned %08x\n", Status);
+            
+            if (file_read)
+                ExFreePool(context.va);
+            
             goto exit;
         }
+        
+        if (file_read) {
+            RtlCopyMemory(buf, context.va, length);
+            ExFreePool(context.va);
+        }
     } else if (type == BLOCK_FLAG_RAID6) {
-        Status = read_data_raid6(Vcb, buf, addr, length, Irp, context, ci, devices, stripestart, stripeend, offset, firststripesize, check_nocsum_parity);
+        Status = read_data_raid6(Vcb, file_read ? context.va : buf, addr, length, &context, ci, devices, offset, generation, c);
         if (!NT_SUCCESS(Status)) {
             ERR("read_data_raid6 returned %08x\n", Status);
+            
+            if (file_read)
+                ExFreePool(context.va);
+            
             goto exit;
         }
+
+        if (file_read) {
+            RtlCopyMemory(buf, context.va, length);
+            ExFreePool(context.va);
+        }
     }
 
 exit:
-    if (stripestart) ExFreePool(stripestart);
-    if (stripeend) ExFreePool(stripeend);
+    if (dummy_mdl)
+        IoFreeMdl(dummy_mdl);
+    
+    if (dummypage)
+        ExFreePool(dummypage);
 
     for (i = 0; i < ci->num_stripes; i++) {
-        if (context->stripes[i].Irp) {
-            if (devices[i]->devobj->Flags & DO_DIRECT_IO) {
-                MmUnlockPages(context->stripes[i].Irp->MdlAddress);
-                IoFreeMdl(context->stripes[i].Irp->MdlAddress);
-            }
-            IoFreeIrp(context->stripes[i].Irp);
+        if (context.stripes[i].mdl) {
+            if (context.stripes[i].mdl->MdlFlags & MDL_PAGES_LOCKED)
+                MmUnlockPages(context.stripes[i].mdl);
+
+            IoFreeMdl(context.stripes[i].mdl);
         }
         
-        if (context->stripes[i].buf)
-            ExFreePool(context->stripes[i].buf);
+        if (context.stripes[i].Irp)
+            IoFreeIrp(context.stripes[i].Irp);
+        
+        if (context.stripes[i].buf && !context.stripes[i].not_alloc)
+            ExFreePool(context.stripes[i].buf);
     }
 
-    ExFreePool(context->stripes);
-    ExFreePool(context);
+    ExFreePool(context.stripes);
     
     if (!Vcb->log_to_phys_loaded)
         ExFreePool(devices);
@@ -2990,7 +2487,7 @@
     return Status;
 }
 
-NTSTATUS STDCALL read_file(fcb* fcb, UINT8* data, UINT64 start, UINT64 length, ULONG* pbr, PIRP Irp, BOOL check_nocsum_parity) {
+NTSTATUS STDCALL read_file(fcb* fcb, UINT8* data, UINT64 start, UINT64 length, ULONG* pbr, PIRP Irp) {
     NTSTATUS Status;
     EXTENT_DATA* ed;
     UINT64 bytes_read = 0;
@@ -3025,7 +2522,7 @@
         EXTENT_DATA2* ed2;
         
         if (!ext->ignore) {
-            ed = ext->data;
+            ed = &ext->extent_data;
             
             ed2 = (ed->type == EXTENT_TYPE_REGULAR || ed->type == EXTENT_TYPE_PREALLOC) ? (EXTENT_DATA2*)ed->data : NULL;
             
@@ -3081,9 +2578,11 @@
                     UINT64 off = start + bytes_read - ext->offset;
                     UINT32 to_read, read;
                     UINT8* buf;
+                    BOOL mdl = (Irp && Irp->MdlAddress) ? TRUE : FALSE;
                     BOOL buf_free;
-                    UINT32 bumpoff = 0;
-                    UINT64 addr, lockaddr, locklen;
+                    UINT32 bumpoff = 0, *csum;
+                    UINT64 addr;
+//                     UINT64 lockaddr, locklen;
                     chunk* c;
                     
                     read = len - off;
@@ -3116,6 +2615,8 @@
                             Status = STATUS_INSUFFICIENT_RESOURCES;
                             goto exit;
                         }
+                        
+                        mdl = FALSE;
                     }
                     
                     c = get_chunk_from_address(fcb->Vcb, addr);
@@ -3129,18 +2630,25 @@
                         goto exit;
                     }
                     
-                    if (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6) {
-                        get_raid56_lock_range(c, addr, to_read, &lockaddr, &locklen);
-                        chunk_lock_range(fcb->Vcb, c, lockaddr, locklen);
-                    }
+//                     if (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6) {
+//                         get_raid56_lock_range(c, addr, to_read, &lockaddr, &locklen);
+//                         chunk_lock_range(fcb->Vcb, c, lockaddr, locklen);
+//                     }
                     
-                    Status = read_data(fcb->Vcb, addr, to_read, ext->csum ? &ext->csum[off / fcb->Vcb->superblock.sector_size] : NULL, FALSE,
-                                       buf, c, NULL, Irp, check_nocsum_parity);
+                    if (ext->csum) {
+                        if (ed->compression == BTRFS_COMPRESSION_NONE)
+                            csum = &ext->csum[off / fcb->Vcb->superblock.sector_size];
+                        else
+                            csum = ext->csum;
+                    } else
+                        csum = NULL;
+                    
+                    Status = read_data(fcb->Vcb, addr, to_read, csum, FALSE, buf, c, NULL, Irp, 0, mdl, bytes_read);
                     if (!NT_SUCCESS(Status)) {
                         ERR("read_data returned %08x\n", Status);
                         
-                        if (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6)
-                            chunk_unlock_range(fcb->Vcb, c, lockaddr, locklen);
+//                         if (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6)
+//                             chunk_unlock_range(fcb->Vcb, c, lockaddr, locklen);
                         
                         if (buf_free)
                             ExFreePool(buf);
@@ -3148,37 +2656,103 @@
                         goto exit;
                     }
                     
-                    if (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6)
-                        chunk_unlock_range(fcb->Vcb, c, lockaddr, locklen);
+//                     if (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6)
+//                         chunk_unlock_range(fcb->Vcb, c, lockaddr, locklen);
                     
                     if (ed->compression == BTRFS_COMPRESSION_NONE) {
                         if (buf_free)
                             RtlCopyMemory(data + bytes_read, buf + bumpoff, read);
                     } else {
-                        UINT8* decomp = NULL;
+                        UINT8 *decomp = NULL, *buf2;
+                        ULONG outlen, inlen, off2;
+                        UINT32 inpageoff = 0;
                         
-                        // FIXME - don't mess around with decomp if we're reading the whole extent
+                        off2 = ed2->offset + off;
+                        buf2 = buf;
+                        inlen = ed2->size;
                         
-                        decomp = ExAllocatePoolWithTag(PagedPool, ed->decoded_size, ALLOC_TAG);
-                        if (!decomp) {
-                            ERR("out of memory\n");
-                            ExFreePool(buf);
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            goto exit;
+                        if (ed->compression == BTRFS_COMPRESSION_LZO) {
+                            ULONG inoff = sizeof(UINT32);
+                            
+                            inlen -= sizeof(UINT32);
+                            
+                            // If reading a few sectors in, skip to the interesting bit
+                            while (off2 > LINUX_PAGE_SIZE) {
+                                UINT32 partlen;
+                                
+                                if (inlen < sizeof(UINT32))
+                                    break;
+                                
+                                partlen = *(UINT32*)(buf2 + inoff);
+                                
+                                if (partlen < inlen) {
+                                    off2 -= LINUX_PAGE_SIZE;
+                                    inoff += partlen + sizeof(UINT32);
+                                    inlen -= partlen + sizeof(UINT32);
+                                    
+                                    if (LINUX_PAGE_SIZE - (inoff % LINUX_PAGE_SIZE) < sizeof(UINT32))
+                                        inoff = ((inoff / LINUX_PAGE_SIZE) + 1) * LINUX_PAGE_SIZE;
+                                } else
+                                    break;
+                            }
+                            
+                            buf2 = &buf2[inoff];
+                            inpageoff = inoff % LINUX_PAGE_SIZE;
                         }
                         
-                        Status = decompress(ed->compression, buf, ed2->size, decomp, ed->decoded_size);
+                        if (off2 != 0) {
+                            outlen = off2 + min(read, ed2->num_bytes - off);
+                            
+                            decomp = ExAllocatePoolWithTag(PagedPool, outlen, ALLOC_TAG);
+                            if (!decomp) {
+                                ERR("out of memory\n");
+                                ExFreePool(buf);
+                                Status = STATUS_INSUFFICIENT_RESOURCES;
+                                goto exit;
+                            }
+                        } else
+                            outlen = min(read, ed2->num_bytes - off);
                         
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("decompress returned %08x\n", Status);
+                        if (ed->compression == BTRFS_COMPRESSION_ZLIB) {
+                            Status = zlib_decompress(buf2, inlen, decomp ? decomp : (data + bytes_read), outlen);
+                            
+                            if (!NT_SUCCESS(Status)) {
+                                ERR("zlib_decompress returned %08x\n", Status);
+                                ExFreePool(buf);
+                                
+                                if (decomp)
+                                    ExFreePool(decomp);
+                                
+                                goto exit;
+                            }
+                        } else if (ed->compression == BTRFS_COMPRESSION_LZO) {
+                            Status = lzo_decompress(buf2, inlen, decomp ? decomp : (data + bytes_read), outlen, inpageoff);
+                        
+                            if (!NT_SUCCESS(Status)) {
+                                ERR("lzo_decompress returned %08x\n", Status);
+                                ExFreePool(buf);
+                                
+                                if (decomp)
+                                    ExFreePool(decomp);
+                                
+                                goto exit;
+                            }
+                        } else {
+                            ERR("unsupported compression type %x\n", ed->compression);
+                            Status = STATUS_NOT_SUPPORTED;
+                            
                             ExFreePool(buf);
-                            ExFreePool(decomp);
+                            
+                            if (decomp)
+                                ExFreePool(decomp);
+                            
                             goto exit;
                         }
                         
-                        RtlCopyMemory(data + bytes_read, decomp + ed2->offset + off, min(read, ed2->num_bytes - off));
-                        
-                        ExFreePool(decomp);
+                        if (decomp) {
+                            RtlCopyMemory(data + bytes_read, decomp + off2, min(read, ed2->num_bytes - off));
+                            ExFreePool(decomp);
+                        }
                     }
                     
                     if (buf_free)
@@ -3380,7 +2954,7 @@
         if (fcb->ads)
             Status = read_stream(fcb, data, start, length, bytes_read);
         else
-            Status = read_file(fcb, data, start, length, bytes_read, Irp, TRUE);
+            Status = read_file(fcb, data, start, length, bytes_read, Irp);
         
         *bytes_read += addon;
         TRACE("read %u bytes\n", *bytes_read);
@@ -3422,9 +2996,12 @@
     
     TRACE("read\n");
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_read(DeviceObject, Irp);
         goto exit2;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
     
     Irp->IoStatus.Information = 0;
@@ -3493,8 +3070,6 @@
 exit:
     if (fcb_lock)
         ExReleaseResourceLite(fcb->Header.Resource);
-
-    Irp->IoStatus.Status = Status;
     
     if (FileObject->Flags & FO_SYNCHRONOUS_IO && !(Irp->Flags & IRP_PAGING_IO))
         FileObject->CurrentByteOffset.QuadPart = IrpSp->Parameters.Read.ByteOffset.QuadPart + (NT_SUCCESS(Status) ? bytes_read : 0);
@@ -3503,6 +3078,9 @@
     if (Irp->UserIosb)
         *Irp->UserIosb = Irp->IoStatus;
     
+end:
+    Irp->IoStatus.Status = Status;
+    
     TRACE("Irp->IoStatus.Status = %08x\n", Irp->IoStatus.Status);
     TRACE("Irp->IoStatus.Information = %lu\n", Irp->IoStatus.Information);
     TRACE("returning %08x\n", Status);
Index: drivers/filesystems/btrfs/registry.c
===================================================================
--- drivers/filesystems/btrfs/registry.c	(révision 74430)
+++ drivers/filesystems/btrfs/registry.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
@@ -27,7 +27,7 @@
     BTRFS_UUID* uuid = &Vcb->superblock.uuid;
     mount_options* options = &Vcb->options;
     UNICODE_STRING path, ignoreus, compressus, compressforceus, compresstypeus, readonlyus, zliblevelus, flushintervalus,
-                   maxinlineus, subvolidus, raid5recalcus, raid6recalcus, skipbalanceus;
+                   maxinlineus, subvolidus, skipbalanceus, nobarrierus, notrimus, clearcacheus;
     OBJECT_ATTRIBUTES oa;
     NTSTATUS Status;
     ULONG i, j, kvfilen, index, retlen;
@@ -41,9 +41,10 @@
     options->zlib_level = mount_zlib_level;
     options->flush_interval = mount_flush_interval;
     options->max_inline = min(mount_max_inline, Vcb->superblock.node_size - sizeof(tree_header) - sizeof(leaf_node) - sizeof(EXTENT_DATA) + 1);
-    options->raid5_recalculation = mount_raid5_recalculation;
-    options->raid6_recalculation = mount_raid6_recalculation;
     options->skip_balance = mount_skip_balance;
+    options->no_barrier = mount_no_barrier;
+    options->no_trim = mount_no_trim;
+    options->clear_cache = mount_clear_cache;
     options->subvol_id = 0;
     
     path.Length = path.MaximumLength = registry_path.Length + (37 * sizeof(WCHAR));
@@ -102,9 +103,10 @@
     RtlInitUnicodeString(&flushintervalus, L"FlushInterval");
     RtlInitUnicodeString(&maxinlineus, L"MaxInline");
     RtlInitUnicodeString(&subvolidus, L"SubvolId");
-    RtlInitUnicodeString(&raid5recalcus, L"Raid5Recalculation");
-    RtlInitUnicodeString(&raid6recalcus, L"Raid6Recalculation");
     RtlInitUnicodeString(&skipbalanceus, L"SkipBalance");
+    RtlInitUnicodeString(&nobarrierus, L"NoBarrier");
+    RtlInitUnicodeString(&notrimus, L"NoTrim");
+    RtlInitUnicodeString(&clearcacheus, L"ClearCache");
     
     do {
         Status = ZwEnumerateValueKey(h, index, KeyValueFullInformation, kvfi, kvfilen, &retlen);
@@ -153,18 +155,22 @@
                 UINT64* val = (UINT64*)((UINT8*)kvfi + kvfi->DataOffset);
                 
                 options->subvol_id = *val;
-            } else if (FsRtlAreNamesEqual(&raid5recalcus, &us, TRUE, NULL) && kvfi->DataOffset > 0 && kvfi->DataLength > 0 && kvfi->Type == REG_DWORD) {
+            } else if (FsRtlAreNamesEqual(&skipbalanceus, &us, TRUE, NULL) && kvfi->DataOffset > 0 && kvfi->DataLength > 0 && kvfi->Type == REG_DWORD) {
                 DWORD* val = (DWORD*)((UINT8*)kvfi + kvfi->DataOffset);
                 
-                options->raid5_recalculation = *val;
-            } else if (FsRtlAreNamesEqual(&raid6recalcus, &us, TRUE, NULL) && kvfi->DataOffset > 0 && kvfi->DataLength > 0 && kvfi->Type == REG_DWORD) {
+                options->skip_balance = *val;
+            } else if (FsRtlAreNamesEqual(&nobarrierus, &us, TRUE, NULL) && kvfi->DataOffset > 0 && kvfi->DataLength > 0 && kvfi->Type == REG_DWORD) {
                 DWORD* val = (DWORD*)((UINT8*)kvfi + kvfi->DataOffset);
                 
-                options->raid6_recalculation = *val;
-            } else if (FsRtlAreNamesEqual(&skipbalanceus, &us, TRUE, NULL) && kvfi->DataOffset > 0 && kvfi->DataLength > 0 && kvfi->Type == REG_DWORD) {
+                options->no_barrier = *val;
+            } else if (FsRtlAreNamesEqual(&notrimus, &us, TRUE, NULL) && kvfi->DataOffset > 0 && kvfi->DataLength > 0 && kvfi->Type == REG_DWORD) {
                 DWORD* val = (DWORD*)((UINT8*)kvfi + kvfi->DataOffset);
                 
-                options->skip_balance = *val;
+                options->no_trim = *val;
+            } else if (FsRtlAreNamesEqual(&clearcacheus, &us, TRUE, NULL) && kvfi->DataOffset > 0 && kvfi->DataLength > 0 && kvfi->Type == REG_DWORD) {
+                DWORD* val = (DWORD*)((UINT8*)kvfi + kvfi->DataOffset);
+                
+                options->clear_cache = *val;
             }
         } else if (Status != STATUS_NO_MORE_ENTRIES) {
             ERR("ZwEnumerateValueKey returned %08x\n", Status);
@@ -181,12 +187,6 @@
     if (options->flush_interval == 0)
         options->flush_interval = mount_flush_interval;
     
-    if (options->raid5_recalculation > 1)
-        options->raid5_recalculation = 1;
-    
-    if (options->raid6_recalculation > 2)
-        options->raid6_recalculation = 2;
-
     Status = STATUS_SUCCESS;
     
 end2:
@@ -636,7 +636,7 @@
     KEY_VALUE_FULL_INFORMATION* kvfi;
 #endif
     
-#ifndef __REACTOS__    
+#ifndef __REACTOS__
     static WCHAR def_log_file[] = L"\\??\\C:\\btrfs.log";
 #endif
     
@@ -659,19 +659,14 @@
     get_registry_value(h, L"ZlibLevel", REG_DWORD, &mount_zlib_level, sizeof(mount_zlib_level));
     get_registry_value(h, L"FlushInterval", REG_DWORD, &mount_flush_interval, sizeof(mount_flush_interval));
     get_registry_value(h, L"MaxInline", REG_DWORD, &mount_max_inline, sizeof(mount_max_inline));
-    get_registry_value(h, L"Raid5Recalculation", REG_DWORD, &mount_raid5_recalculation, sizeof(mount_raid5_recalculation));
-    get_registry_value(h, L"Raid6Recalculation", REG_DWORD, &mount_raid6_recalculation, sizeof(mount_raid6_recalculation));
     get_registry_value(h, L"SkipBalance", REG_DWORD, &mount_skip_balance, sizeof(mount_skip_balance));
+    get_registry_value(h, L"NoBarrier", REG_DWORD, &mount_no_barrier, sizeof(mount_no_barrier));
+    get_registry_value(h, L"NoTrim", REG_DWORD, &mount_no_trim, sizeof(mount_no_trim));
+    get_registry_value(h, L"ClearCache", REG_DWORD, &mount_clear_cache, sizeof(mount_clear_cache));
     
     if (mount_flush_interval == 0)
         mount_flush_interval = 1;
     
-    if (mount_raid5_recalculation > 1)
-        mount_raid5_recalculation = 1;
-    
-    if (mount_raid6_recalculation > 2)
-        mount_raid6_recalculation = 2;
-    
 #ifdef _DEBUG
     get_registry_value(h, L"DebugLogLevel", REG_DWORD, &debug_log_level, sizeof(debug_log_level));
     
Index: drivers/filesystems/btrfs/reparse.c
===================================================================
--- drivers/filesystems/btrfs/reparse.c	(révision 74430)
+++ drivers/filesystems/btrfs/reparse.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
@@ -56,7 +56,7 @@
             }
             
             TRACE("data = %p, size = %x\n", data, fcb->inode_item.st_size);
-            Status = read_file(fcb, (UINT8*)data, 0, fcb->inode_item.st_size, NULL, NULL, TRUE);
+            Status = read_file(fcb, (UINT8*)data, 0, fcb->inode_item.st_size, NULL, NULL);
             
             if (!NT_SUCCESS(Status)) {
                 ERR("read_file returned %08x\n", Status);
@@ -119,7 +119,7 @@
         if (fcb->type == BTRFS_TYPE_FILE) {
             ULONG len;
             
-            Status = read_file(fcb, buffer, 0, buflen, &len, NULL, TRUE);
+            Status = read_file(fcb, buffer, 0, buflen, &len, NULL);
             
             if (!NT_SUCCESS(Status)) {
                 ERR("read_file returned %08x\n", Status);
@@ -215,7 +215,7 @@
         offset.QuadPart = 0;
         tlength = target.Length;
         Status = write_file2(fileref->fcb->Vcb, Irp, offset, target.Buffer, &tlength, FALSE, TRUE,
-                            TRUE, FALSE, rollback);
+                             TRUE, FALSE, FALSE, rollback);
         ExFreePool(target.Buffer);
     } else
         Status = STATUS_SUCCESS;
@@ -348,7 +348,7 @@
             
             offset.QuadPart = 0;
             
-            Status = write_file2(fcb->Vcb, Irp, offset, buffer, &buflen, FALSE, TRUE, TRUE, FALSE, &rollback);
+            Status = write_file2(fcb->Vcb, Irp, offset, buffer, &buflen, FALSE, TRUE, TRUE, FALSE, FALSE, &rollback);
             if (!NT_SUCCESS(Status)) {
                 ERR("write_file2 returned %08x\n", Status);
                 goto end;
@@ -381,7 +381,7 @@
     
 end:
     if (NT_SUCCESS(Status))
-        clear_rollback(fcb->Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(fcb->Vcb, &rollback);
 
@@ -575,7 +575,7 @@
     
 end:
     if (NT_SUCCESS(Status))
-        clear_rollback(fcb->Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(fcb->Vcb, &rollback);
     
